
<!-- Warning: This file has been autogenerated by tools/makedoc.py. Manual edits will be overwritten. -->
<html>
    <head>
        <title>freesmartphone.org GSM Call Forwarding Interface</title>
        <link rel="stylesheet" type="text/css" href="http://git.freesmartphone.org/?p=specs.git;a=blob_plain;f=html/style.css;hb=HEAD" />
    </head>
    <body>
    <div class="topbox">freesmartphone.org Framework DBus Interface Specification</div>


<h1>org.freesmartphone.GSM.CallForwarding</h1><h2>Description</h2>
<p>The call forwarding interface allows to access the call forwarding  supplementary service according to 3GPP TS 22.082. It supports  enabling and disabling different voice related call forwarding rules  and to query their current status.</p>
<h2>Namespace</h2>
<p><tt>org.freesmartphone.GSM.CallForwarding</tt></p>
<h2>Methods</h2><ul>
<li><a href="#DisableAll">DisableAll</a></li>
<li><a href="#Enable">Enable</a></li>
<li><a href="#Disable">Disable</a></li>
<li><a href="#GetStatus">GetStatus</a></li>
</ul>
<h2>Signals</h2><ul>
<li><a href="#StatusChanged">StatusChanged</a></li>
</ul>
<h2>Properties</h2><i>None</i>
<h2>Errors</h2><i>None</i>
<h1>Methods</h1><h3><a name="DisableAll">DisableAll</a> ( s )</h3>
<p><i>Description:</i> Disable all (or only conditional) call forwarding rules. </p><h4>Parameters</h4><i>s: type</i><p>Type of call forwarding rules to disable. Expected values are  <ul>  <li>"all": disable all rules,</li>  <li>"conditional": disable only coniditonal rules  (e.g. busy, not reachable, no reply).</li>  </ul> </p>
<h3><a name="Enable">Enable</a> ( ssi )</h3>
<p><i>Description:</i> Enable a call forwarding rule. The corresponding properties for the  specified rules will be populated with the values specified. </p><h4>Parameters</h4><i>s: rule</i><p>Call forwarding rule to assign a number and timeout for. Expected values are:  <ul>  <li>"voice unconditional",</li>  <li>"voice busy",</li>  <li>"voice no reply",</li>  <li>"voice not reachable".</li>  </ul> </p><i>s: number</i><p>Number the call should be forwarded too. Should be either in national  or international format. </p><i>i: timeout</i><p>Timeout after the call forwarding rule should become active. Only accepted  if rule is "voice no reply". </p>
<h3><a name="Disable">Disable</a> ( s )</h3>
<p><i>Description:</i> Disable a call forwarding rule. </p><h4>Parameters</h4><i>s: rule</i><p>Name of the call forwarding rule. See  <a href="http://docs.freesmartphone.org/org.freesmartphone.GSM.CallForwarding.html#Enable">Enable</a> for a list  of valid values.  The corresponding property for the rule will be unset. </p>
<h3><a name="GetStatus">GetStatus</a> ( s ) &rarr; a{sv}</h3>
<p><i>Description:</i> Retrieve the current status for a call forwarding rule. </p><h4>Parameters</h4><i>s: rule</i><p>Name of the call forwarding rule. See  <a href="http://docs.freesmartphone.org/org.freesmartphone.GSM.CallForwarding.html#Enable">Enable</a> for a list  of valid values. </p><h4>Returns</h4><i>a{sv}: status</i><p>Status of the call forwarding rule. See <a href="http://docs.freesmartphone.org/org.freesmartphone.GSM.CallForwarding.html#StatusChanged">StatusChanged</a>  for a description of the format. </p>
<h1>Signals</h1><h3><h3><a name="StatusChanged">StatusChanged</a> ( sa{sv} )</h3><p><i>Description:</i> Sent whenver a status of a call forwarding rule has changed. </p><h4>Parameters</h4><i>s: rule</i><p>Name of the call forwarding rule it's status has changed. </p><i>a{sv}: status</i><p>Changed status of the call forwarding rule. Expected values are:  <ul>  <li>"active": boolean: Wether the rule is active or not</li>  <li>  "number": string: Number for the call forwarding rule; is empty  if the rule is not active.  </li>  </ul>  If the status of the rule "voice no reply has changed" there is an  additional entry:  <ul>  <li>  "timeout": uint16: Value of the voice "no reply" timeout in  seconds. Should be in a range of [1:30].  </li>  </ul> </p></h3>

    <hr/>
    <small>
    | Specified 2008-2012 by the <a href="http://www.freesmartphone.org">Freesmartphone.org</a> team. | Join us and discuss further drafts smartphones-standards (at) linuxtogo (dot) org
    </small>
    <hr/>
    </body>
</html>

